import { BaseFilter } from './BaseFilter';
import { BaseQuery } from './BaseQuery';
import { DimensionDefinition, SegmentDefinition } from '../compiler/CubeEvaluator';
import { Granularity } from './Granularity';
export declare class BaseTimeDimension extends BaseFilter {
    readonly dateRange: [string, string];
    readonly granularityObj: Granularity | undefined;
    readonly boundaryDateRange: any;
    readonly shiftInterval: string;
    constructor(query: BaseQuery, timeDimension: any);
    get granularity(): string | null | undefined;
    selectColumns(): string[] | null;
    hasNoRemapping(): any;
    aliasName(): string | null;
    unescapedAliasName(granularity?: string): any;
    dateSeriesAliasName(): string;
    dateSeriesSelectColumn(dateSeriesAliasName: string | null, dateSeriesGranularity?: string): string | null;
    dimensionSql(): any;
    dimensionDefinition(): DimensionDefinition | SegmentDefinition;
    convertTzForRawTimeDimensionIfNeeded(sql: any): any;
    convertedToTz(): string;
    filterToWhere(): any;
    filterParams(): any[];
    protected dateFromFormattedValue: string | null;
    dateFromFormatted(): string;
    protected dateFromValue: any | null;
    dateFrom(): any;
    dateFromParam(): string;
    localDateTimeFromParam(): string;
    localDateTimeFromOrBuildRangeParam(): string;
    protected dateToFormattedValue: string | null;
    dateToFormatted(): string;
    protected dateToValue: any | null;
    dateTo(): any;
    dateToParam(): string;
    localDateTimeToParam(): string;
    localDateTimeToOrBuildRangeParam(): string;
    dateRangeGranularity(): string | null;
    protected rollupGranularityValue: string | null;
    rollupGranularity(): string | null;
    timeSeries(): string[][];
    resolvedGranularity(): string | null;
    wildcardRange(): string[];
    boundaryDateRangeFormatted(): any;
}
//# sourceMappingURL=BaseTimeDimension.d.ts.map